extends Label

@export
var public := true
@export
var show_to_peer := false

func _enter_tree():
	print("Entering tree %s, visible %s %s" % [text.to_int(), public, show_to_peer])

func _ready():
	print("Ready %s, visible %s %s" % [text.to_int(), public, show_to_peer])


func is_visible_to(peer):
	return public or (show_to_peer and str(peer) == str(name))


func _process(delta):
	if not is_multiplayer_authority():
		return
	%Counter.value += delta
	%StaticCounter.value += delta


func _on_all_toggled(button_pressed):
	if not is_multiplayer_authority():
		return
	public = button_pressed
	if public: # Ensure this gets spawned before items.
		%PlayerSync.update_visibility()
	%ItemSpawner.public = button_pressed


func _on_one_toggled(button_pressed):
	show_to_peer = button_pressed
	if show_to_peer: # Ensure this gets spawned before items.
		%PlayerSync.update_visibility()
	%ItemSpawner.show_to_peer = str(name).to_int() if button_pressed else 1


func _on_spawn_pressed():
	%ItemSpawner.spawn()


func _on_despawn_pressed():
	%ItemSpawner.despawn()
